//  Demo 12: ThreadPracticeA.java
//
//   A Simple Java Application to Use the FirstMovingSquareThread Class
//   Illustrates creating a separate Thread of execution by calling
//   the start method of a Thread class we have written.
//
//             by Charles W. Neville
//      Copyright Charles W. Neville, July, 1999

// This application launches a Square which moves smoothly across
// the screen.

// You can stop this application while it the animation is running
// by clicking on the Frame window close button.  This is very
// simple event processing, but it is possible because the animation
// runs in a separate Thread of execution, thus leaving the main 
// application free to process events.

// Threads:
//
//   1. Main Thread -- this application.  Every running Java program
//        contains at least one Thread, the Thread main() runs on.
//   2. A separate Thread for the animation.  The moving Square
//        is actually a separate FirstMovingSquareThread object,
//        launched by invoking the library start() method of the Thread
//        class. The start() method sets the new Thread up to run and 
//        then calls the run() method of our FirstMovingSquareThread 
//        class.  Our run() method is where the animation code goes.

import java.awt.*;
import java.awt.event.*;
import CloseAndExit;
import FirstMovingSquareThread;

public class ThreadPracticeA extends Frame {

    FirstMovingSquareThread fmst;  // our moving Square animation

    // Constructor: as usual, initializes variables.
    public ThreadPracticeA() {

       fmst = new FirstMovingSquareThread( new Square(50, 50, 25, 
                    Color.blue), this, 1, 1, 200);

       addWindowListener(new CloseAndExit());   // as usual

    } // Constructor ThreadPracticeA()

    public static void main(String[ ] args) {

       ThreadPracticeA tpa = new ThreadPracticeA();
       tpa.setSize(400, 400);
       tpa.setVisible(true);
       tpa.fmst.start();

    } // main()

} // class ThreadPracticeA
